/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Polygon;
import org.newdawn.slick.geom.Shape;

/**
 * This class is a simple block (rectangle) implementation of
 * <code>ICollidableObject</code>.
 *
 * @author sam
 */
public class Block implements ICollidableObject {

    public Polygon poly;

    /**
     * constructs a new block.
     * Its position will be defined by the given x and y values and its
     * width and higth by the provided values as well.
     *
     * @param x
     * @param y
     * @param width
     * @param higth
     */
    public Block(int x, int y, int width, int higth) {
        poly = new Polygon(new float[]{
                    x, y,
                    x + width, y,
                    x + width, y + higth,
                    x, y + higth});
    }

    @Override
    public Shape getCollisionShape() {
        return poly;
    }

    @Override
    public Shape getNormalCollisionShape() {
        return poly;
    }

    @Override
    public boolean isCollidingWith(ICollidableObject collidable) {
        return this.getCollisionShape().intersects(collidable.getCollisionShape());
    }

    /**
     * calls the draw method of <code>Graphics</code> with the polygon
     * residing in this class.
     *
     * @param g
     */
    public void draw(Graphics g) {
        g.draw(poly);
    }
}