/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.newdawn.slick.geom.Path;
import org.newdawn.slick.geom.Polygon;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.geom.Vector2f;

// TODO this is not very efficient
/**
 * This *AI* is smarter than the Simple one.
 * It adjusts the range in which random number are found according to the
 * last impact and the position of the enemy.
 * What it does not do:
 * check for walls. so it can happen, that it gets stuck and does not stop throwing
 * things against the wall, never trying a wider range again.
 *
 * @author sam
 */
public class EnemyAIMediumBACKUP extends AbstractEnemyAI implements IEnemyAI {

    /** the angle of the previous throw. */
    private float prevBeta;
    /** the velocity of the previous throw. */
    private float prevVel;

    /* current restraints for random new beta and velocity values.
     note, that beta is negativ, so min and max actually mean different things. */
    private float currMinBeta;
    private float currMaxBeta;
    private float currMinVel;
    private float currMaxVel;

    /** calculated values for next throw. */
    private float radianBeta;
    private float velocity;

    /** area that can be covert by min/max values. */
    public Shape hitArea;

    /**
     * constructs a new medium ai.
     *
     * @param banana
     */
    public EnemyAIMediumBACKUP(BlockMap map) {
        super(map);
        super.MINTHINKINGTIME = 20;
        super.MAXTHINKINGTIME = 30;
        currMinBeta = super.MINBETA;
        currMaxBeta = super.MAXBETA;
        currMinVel = super.MINVELOCITY;
        currMaxVel = super.MAXVELOCITY;
    }

    @Override
    public void calculateVelocityBeta() {
        radianBeta = calculateBeta();
        velocity = calculateVelocity();
    }

    @Override
    public float getBeta() {
        return radianBeta;
    }

    @Override
    public float getVelocity() {
        return velocity;
    }

    /**
     * returns a random beta value in between the current min/max values as defined
     * by the call to reCalculateMinMaxBeta.
     *
     * @return
     */
    public float calculateBeta() {
        reCalculateMinMaxBeta();
        correctCalculations();
        float beta = randomBetween((int) currMinBeta, (int) currMaxBeta);
        prevBeta = beta;
        return (float) Math.toRadians(beta);
    }

    /**
     * returns a random velocity value in between the current min/max values as defined
     * by the call to reCalcualteMinMaxVel.
     *
     * @return
     */
    public float calculateVelocity() {
        reCalcualteMinMaxVel();
        correctCalculations();
        float vel =  randomBetween((int) currMinVel, (int) currMaxVel);
        prevVel = vel;
        return vel;
    }

    // FIXME problem: min/max are not very practical here, because 45 is "max" and everything far away is "min"
    // also, no wall check.
    /**
     * checks if the place, where the banana landed last is bevor or behind the players
     * ape and sets either the currentMinBeta or currentMaxBeta to the beta value of that previous throw.
     * If the new current min/max value results in the case, that the enemy cannot be hit anymore, it will not be set.
     */
    protected void reCalculateMinMaxBeta() {
        if (super.map.getBanana2().getPositionBeforSpawn() == null) {
            return;
        } else {
            Vector2f positionBeforSpawn = super.map.getBanana2().getPositionBeforSpawn();
            if (positionBeforSpawn.x < super.map.getApe().getCollisionShape().getCenterX()) { //throw went too far
                float possNewMinBeta = currMinBeta;
                float possNewMaxBeta = currMaxBeta;
                if (prevBeta > -45) { // TODO bring walls in this calculation.
                    possNewMinBeta = prevBeta;  // enshure, that it will never fly even farther
                } else {
                    possNewMaxBeta = prevBeta; // enshure, that it will never fly even farther
                }
                if (isHitPossible(possNewMinBeta, currMinVel, possNewMaxBeta, currMaxVel)) {
                    currMaxBeta = possNewMaxBeta;
                    currMinBeta = possNewMinBeta;
                }
            } else if (positionBeforSpawn.x > super.map.getApe().getCollisionShape().getCenterX()) {
                float possNewMinBeta = currMinBeta;
                float possNewMaxBeta = currMaxBeta;
                if (prevBeta > -45) {
                    possNewMaxBeta = prevBeta;
                } else {
                    possNewMinBeta = prevBeta;
                }
                if (isHitPossible(possNewMinBeta, currMinVel, possNewMaxBeta, currMaxVel)) {
                    currMaxBeta = possNewMaxBeta;
                    currMinBeta = possNewMinBeta;
                }
            }
        }
    }

    /**
     * see reCalculateMinMaxBeta but for the velocity (and also working...).
     */
    protected void reCalcualteMinMaxVel() {
        if (super.map.getBanana2().getPositionBeforSpawn() == null) {
            return;
        } else {
            Vector2f positionBeforSpawn = super.map.getBanana2().getPositionBeforSpawn();
            if (positionBeforSpawn.x < super.map.getApe().getCollisionShape().getCenterX()) {
                float possNewMinVel = prevVel;
                if (isHitPossible(currMinBeta, possNewMinVel, currMaxBeta, currMaxVel)) {
                    currMinVel = possNewMinVel;
                }
            } else if (positionBeforSpawn.x > super.map.getApe().getCollisionShape().getCenterX()) {
                float possNewMaxVel = prevVel;
                if (isHitPossible(currMinBeta, currMinVel, currMaxBeta, possNewMaxVel)) {
                    currMaxVel = possNewMaxVel;
                }
            }
        }
    }

    /**
     * returns weather or not the enemy can be hit with some value between the given
     * min/max values.
     *
     * @param minBeta
     * @param minVel
     * @param maxBeta
     * @param maxVel
     * @return
     */
    protected boolean isHitPossible(float minBeta,
        float minVel,
        float maxBeta,
        float maxVel) {

        float tempRealMinBeta;
        float tempRealMaxBeta;
        if (diffTo45(minBeta) > diffTo45(maxBeta)) {
            tempRealMinBeta = minBeta;
            tempRealMaxBeta = maxBeta;
        } else {
            tempRealMinBeta = maxBeta;
            tempRealMaxBeta = minBeta;
        }

        Path minCurve = map.getBanana2().getYForX(9.8f, tempRealMinBeta, minVel, gc);
        Path maxCurve = map.getBanana2().getYForX(9.8f, tempRealMaxBeta, maxVel, gc);
        maxCurve.lineTo(0, gc.getScreenHeight());

        for (int i = minCurve.getPointCount() - 1; i > 0; i--) {
            float[] point = minCurve.getPoint(i);
            maxCurve.lineTo(point[0], point[1]);
        }
        maxCurve.close();

        hitArea = new Polygon(maxCurve.getPoints());

        if (hitArea.contains(super.map.getApe().getCollisionShape()) || hitArea.intersects(super.map.getApe().getCollisionShape())) {
            return true;
        }
        return false;

    }

    protected float diffTo45(float angle) {
        if ((angle - 45) > 0) {
            return angle - 45;
        } else {
            return 45 - angle;
        }
    }

    protected void correctCalculations() {
       while (currMinBeta >= currMaxBeta) {
           System.err.println("corrected values 1");
           currMinBeta--;
           currMaxBeta++;
        }
        while (currMinVel >= currMaxVel) {
            System.err.println("corrected values 2");
            currMinVel--;
            currMaxVel++;
        }

        if (currMinBeta < super.MINBETA) {
            System.err.println("corrected values 3");
            currMinBeta = super.MINBETA;
        }
        if (currMaxBeta > super.MAXBETA) {
            System.err.println("corrected values 4");
            currMaxBeta = super.MAXBETA;
        }
        if (currMinVel < super.MINVELOCITY) {
            System.err.println("corrected values 5");
            currMinVel = super.MINVELOCITY;
        }
        if (currMaxVel > super.MAXVELOCITY) {
            System.err.println("corrected values 6");
            currMaxVel = super.MAXVELOCITY;
        }
    }
}
