/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

/**
 * Interface for a (Level-) Object.
 * It has a name as well as a position.
 * It must implement the render method which may draw this object to the screen
 * as well as the update method which handles user input.
 *
 * @author sam
 */
public interface ILevelObject {

    /**
     * returns the name of this object.
     *
     * @return
     */
    public String getName();

    /**
     * sets the position of this object.
     *
     * @param position
     */
    public void setPosition(Vector2f position);

    /**
     * returns the position of this object.
     *
     * @return
     */
    public Vector2f getPosition();

    /**
     * renders this object to the screen.
     *
     * @param graphics
     */
    public void render(Graphics graphics);

    /**
     * applies user input to the object.
     *
     * @param gc
     * @param sbg
     * @param delta
     */
    public void update(GameContainer gc, StateBasedGame sbg, int delta);
}
