/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.geom.Vector2f;
import org.newdawn.slick.state.StateBasedGame;

/**
 * This class is responsible for holding image objects.
 * They have a position, a name and an image. They may be printed to the screen
 * and user input may be applied.
 *
 * @author sam
 */
public class ImageObject implements ILevelObject {

    /** the name of this object.*/
    protected String name;
    /** the image this object holds. */
    protected Image image;
    /** the position of this object. */
    protected Vector2f position;

    /**
     * constructs a new object.
     *
     * @param name
     * @param image
     * @param position
     */
    public ImageObject(String name, Image image, Vector2f position) {
        this.name = name;
        this.image = image;
        this.position = position;
    }

    /**
     * returns the name of this object.
     *
     * @return
     */
    @Override
    public String getName() {
        return name;
    }

    /**
     *  returns the position of this object.
     *
     * @return
     */
    @Override
    public Vector2f getPosition() {
        return position;
    }

    /**
     * sets the position of this object.
     *
     * @param position
     */
    @Override
    public void setPosition(Vector2f position) {
        this.position = position;
    }

    /**
     * draws the <code>image</code> on the screen with its top left corner
     * at the given x/y coordinates.
     *
     * @param graphics
     */
    @Override
    public void render(Graphics graphics) {
        image.draw(position.x, position.y);
    }

    /**
     * does nothing at the moment.
     *
     * @param gc
     * @param sbg
     * @param delta
     */
    @Override
    public void update(GameContainer gc, StateBasedGame sbg, int delta) {
    }
}