/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package apes;

import java.util.LinkedList;
import org.newdawn.slick.Animation;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

/**
 * The intro state of the game. It displays it title, etc.
 *
 * @author sam
 */
public class IntroState extends BasicGameState {

    private static int stateID = -1;
    private int phase = 0;
    // phase 0
    private LinkedList<Image> imgs;
    private int currentPic = 0;
    private static int MAXDELTA = 800;
    private int deltaCounter = MAXDELTA;
    // phase 1
    private Image sticky = null;
    private Image logo = null;
    Animation an;
    float anX = 0.0f;
    private float fadeIn = 0.0f;

    public IntroState(int stateID) {
        this.stateID = stateID;
    }

    @Override
    public int getID() {
        return stateID;
    }

    @Override
    public void init(GameContainer gc, StateBasedGame sbg) throws SlickException {
        imgs = new LinkedList<Image>();
        imgs.add(new Image("/data/intro/pic1.gif"));
        imgs.add(new Image("/data/intro/pic2.gif"));
        imgs.add(new Image("/data/intro/pic3.gif"));
        imgs.add(new Image("/data/intro/pic4.gif"));

        an = new Animation(new SpriteSheet("/data/intro/mystickwalking.png", 100, 150), 100);
        sticky = new Image("/data/intro/maskot_white.png");
        logo = new Image("/data/intro/logo.gif");
    }

    @Override
    public void render(GameContainer gc, StateBasedGame sbg, Graphics grphcs) throws SlickException {
        if (phase == 0) {
            imgs.get(currentPic).drawCentered(gc.getScreenWidth() / 2, gc.getScreenHeight() / 2);
            if (deltaCounter < 0) {
                currentPic++;
                deltaCounter = MAXDELTA;
            }
            if (currentPic >= imgs.size()) {
                phase++;
            }
        } else if (phase == 1) {            
                an.draw(anX, sticky.getHeight() + (gc.getScreenHeight() / 6.4f));
                //sticky.draw(gc.getScreenWidth() / 2 - sticky.getWidth() / 2, sticky.getHeight() + (gc.getScreenHeight() / 6.4f));

            logo.draw(gc.getScreenWidth() / 2 - logo.getWidth() / 2, sticky.getHeight() + (gc.getScreenHeight() / 5.6f) + logo.getHeight(), new Color(1f, 1f, 1f, fadeIn));
            if (deltaCounter < 0) {
                fadeIn += 0.005f;
                deltaCounter = 50;
            }
        } else {
            sbg.enterState(Game.MAINMENUSTAT);
        }
    }

    @Override
    public void update(GameContainer gc, StateBasedGame sbg, int i) throws SlickException {
        
        if (phase == 0) {
            deltaCounter -= i;
        }
        if (phase == 1) {
            if (fadeIn < 1) {
                deltaCounter -= i;

            }
            if (anX < gc.getScreenWidth() / 2.1f) {
                anX += (i / 6);
            } else {
                an.setLooping(false);
            }

        }
        Input input = gc.getInput();
        if (input.isKeyPressed(Input.KEY_ESCAPE) || input.isKeyPressed(Input.KEY_ENTER) || input.isMousePressed(input.MOUSE_LEFT_BUTTON)) {
            phase++;
        }
    }
}
